/* cks_cgi.c - CKS Specific CGI functions
 * Copyright (C) 2001-2005 CryptNET, V. Alex Brennen (VAB)
 *
 * This file is part of the CryptNET OpenPGP Public Key Server (cks).
 *
 * cks is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * cks is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "cks_cgi.h"


void print_header(char *title)
{
	printf("Content-Type: text/html\n\n");
	printf(_("<html><head><title>CryptNET OpenPGP Public Key Server</title></head>\n"));
	printf("<body bgcolor=\"#ffffff\">\n");
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<center><h2>CryptNET Keyserver</h2></center>\n"));
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf("<center>\n");
	printf(_("[ <a href=\"index.html\">Search</a> ]\n"));
	printf(_("[ <a href=\"add.html\">Add A Public Key</a> ]\n"));
	printf(_("[ <a href=\"advsrch.html\">Advanced Search</a> ]\n"));
	printf(_("[ <a href=\"sign.html\">Server Key Signing</a> ]<br>\n"));
	printf(_("[ <a href=\"stats/\">Server Statistics</a> ]\n"));
	printf(_("[ <a href=\"keystats.html\">Key Statistics</a> ]\n"));
	printf(_("[ <a href=\"wot.html\">Web of Trust Information</a> ]\n"));
	printf(_("[ <a href=\"help.html\">Help</a> ]\n"));
	printf(_("[ <a href=\"about.html\">About CKS</a> ]\n"));
	printf("</center>\n");
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<h3>%s</h3>\n"), title);

	return;
}


void print_footer(void)
{
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf("<center>\n");
	printf(_("[ <a href=\"index.html\">Search</a> ]\n"));
	printf(_("[ <a href=\"add.html\">Add A Public Key</a> ]\n"));
	printf(_("[ <a href=\"advsrch.html\">Advanced Search</a> ]\n"));
	printf(_("[ <a href=\"sign.html\">Server Key Signing</a> ]<br>\n"));
	printf(_("[ <a href=\"stats/\">Server Statistics</a> ]\n"));
	printf(_("[ <a href=\"keystats.html\">Key Statistics</a> ]\n"));
	printf(_("[ <a href=\"wot.html\">Web of Trust Information</a> ]\n"));
	printf(_("[ <a href=\"help.html\">Help</a> ]\n"));
	printf(_("[ <a href=\"about.html\">About CKS</a> ]\n"));
	printf("</center>\n");
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<center><a href=\"http://keyserver.cryptnet.net/\">CryptNET Key Server Network</a></center>\n"));
	printf("</body></html>\n");

	return;
}


void print_admin_header(char *title)
{
	printf("Content-Type: text/html\n\n");
	printf(_("<html><head><title>CryptNET OpenPGP Public Key Server</title></head>\n"));
	printf("<body bgcolor=\"#ffffff\">\n");
	printf(_("<center><h2>CryptNET Keyserver Administration</h2></center>\n"));
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf("<center>\n");
	printf(_("[ <a href=\"sync_manage.cgi\">Manage Sync Hosts</a> ]\n"));
	printf(_("[ <a href=\"delete.html\">Delete A Key From This Server</a> ]\n"));
	printf(_("[ <a href=\"../stats/\">Stats On This Server</a> ]\n"));
	printf(_("[ <a href=\"index.html\">Admin Home</a> ]\n"));
	printf(_("[ <a href=\"../index.html\">Home</a> ]\n"));
	printf("</center>\n");
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<h3>%s</h3>\n"), title);

	return;
}


void print_admin_footer(void)
{
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf("<center>\n");
	printf(_("[ <a href=\"sync_manage.cgi\">Manage Sync Hosts</a> ]\n"));
	printf(_("[ <a href=\"delete.html\">Delete A Key From This Server</a> ]\n"));
	printf(_("[ <a href=\"../stats/\">Stats On This Server</a> ]\n"));
	printf(_("[ <a href=\"index.html\">Admin Home</a> ]\n"));
	printf(_("[ <a href=\"../index.html\">Home</a> ]\n"));
	printf("</center>\n");
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<center><a href=\"http://keyserver.cryptnet.net/\">CryptNET Key Server Network</a></center>\n"));
	printf("</body></html>\n");

	return;
}


void chk_key_version(unsigned char vrsn)
{
	if(vrsn == (unsigned char)0x04)
	{
		return;
	}
	else if(vrsn == (unsigned char)0x03)
	{
		print_v3_warning();
	}
	else if(vrsn == (unsigned char)0x02)
	{
		print_v2_warning();
	}

	return;
}


void print_v2_warning()
{
	printf("<hr size=\"1\" width=\"100%%\">\n");
	printf(_("<font color=\"red\">Warning</font>\n"));
	printf("<br></br>\n");
	printf(_("<p>You have uploaded a PGP key which is of a version less than 4.\n"));
	printf(_("PGP keys before version 4 have a number of serious weaknesses in them\n"));
	printf(_("which could allow your key, your digitial signatures, or your encrypted\n"));
	printf(_("communications, to be more easily compromised.  CryptNET recommends that\n"));
	printf(_("you revoke all keys which are of a version less than 4.</p>\n"));
	printf("<hr size=\"1\" width=\"100%%\">\n");

	return;
}


void print_v3_warning()
{
	print_v2_warning();

	return;
}
