/* cks_util.c - Utility functions source file
 * Copyright (C) 2001-2005 CryptNET, V. Alex Brennen (VAB)
 *
 * This file is part of the CryptNET OpenPGP Public Key Server (cks).
 *
 * cks is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * cks is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "cks_util.h"


int write_pid_file(char *file_loc)
{
	FILE *pid_file = NULL;
	pid_t	pid = -1;


	pid = getpid();
	if(NULL == (pid_file = fopen(file_loc,"w")))
	{
		fprintf(stderr,"Error: Failed to open pid file: %s\n", file_loc);

		return -1;
	}
	fprintf(pid_file,"%d",pid);
	fclose(pid_file);

	return 0;
}


int delete_pid_file(char *file_loc)
{
	int rslt = 0;


	rslt = remove(file_loc);
	if(rslt == -1)
	{
		fprintf(stderr,"Failed to remove pid file: %s\n", file_loc);
		fprintf(stderr,"Please, remove the file manually.\n");

		return -1;
	}

	return 0;
}
